/*
 * File:   main.c
 * Author: cc
 
 171129 - Jean - Luc
 Rglage course servoi de treuil voilier
 */


#include <xc.h>
#include "main.h"
//#include "LCD_HAC_162J.h"

#define LED PORTCbits.RC2
#define Entree_servo PORTBbits.RB6
#define Sortie_servo PORTBbits.RB5
#define Potentiometre PORTAbits.RA0
#define Bouton_poussoir PORTAbits.RA3

char LED_Nb_tops = 0;
int Duree_impulsion_entree = 0;
int Duree_impulsion_sortie = 0;
int Duree_potentiometre = 0;
int Valeur_ana = 0;
char Ptr = 0;
int Duree_mini_impulsion = 0;
int Duree_maxi_impulsion = 0;
int Duree_mini_servo = 0;
int Duree_maxi_servo = 0;
float coef_a = 0;
float coef_b = 0;
int Duree_impulsion = 0;
char LED_Cptr = 0;
char LED_Nb_flashs = 2;
char Delai_0 = 0;

int Delai_tempo_LED = 0;
int Delai_tempo_sequence = 0;


void main_init(void);
void lecture_EEPROM(void);
void Clignottement_LED (void);

struct {
    union 
    {
        int x;
        char y[2];  // y[0] low  y[1] high  
    };
} Temp;

void interrupt tc_int(void)        // interrupt function
{
    
    if (INTCONbits.RABIE && INTCONbits.RABIF)
    {
        if (Entree_servo == 1)
        {
            // dbut de mesure de la largeur d'impulsion
            T1CONbits.TMR1ON = 0;       // disable TMR1
            TMR1H = 0;
            TMR1L = 0;
            T1CONbits.TMR1ON = 1;       // enable TMR1
        }
        if (Entree_servo == 0)
        {
            // fin de mesure de la largeur d'impulsion
            T1CONbits.TMR1ON = 0;       // disable TMR1
            Temp.y[0] = TMR1L;
            Temp.y[1] = TMR1H;
            Duree_impulsion_entree = Temp.x;
            // dbut mission top servo
            if (Duree_impulsion_sortie < 700) Duree_impulsion_sortie = 700;
            if (Duree_impulsion_sortie > 2300) Duree_impulsion_sortie = 2300;
            Temp.x = Temp.x + Duree_impulsion_sortie;
            CCPR1H = Temp.y[1];
            CCPR1L = Temp.y[0];
            Sortie_servo = 1;
            T1CONbits.TMR1ON = 1;       // enable TMR1
        }
        INTCONbits.RABIF = 0;
    }

    if (PIE1bits.CCP1IE == 1 && PIR1bits.CCP1IF == 1)
    {
        Sortie_servo = 0;
        PIR1bits.CCP1IF = 0;
    }
}
        
int main()
{
    
    
    char init = 0;
    
    main_init();

    // utilis pour initialiser l'EEPROM
    /*
        // largeur impulsion envoye par metteur
        Temp.x = 1100;
        eeprom_write(0, Temp.y[0]);
        eeprom_write(1, Temp.y[1]);
        Temp.x = 1800;
        eeprom_write(2, Temp.y[0]);
        eeprom_write(3, Temp.y[1]);
        // largeur impulsion  envoyer au servo
        Temp.x = 1100;
        eeprom_write(4, Temp.y[0]);
        eeprom_write(5, Temp.y[1]);
        Temp.x = 1800;
        eeprom_write(6, Temp.y[0]);
        eeprom_write(7, Temp.y[1]);
        init = 1;
    */ 
    lecture_EEPROM();

    Ptr = 0;
    ADCON0bits.GO_nDONE = 1;     // dbut conversion analogique
    while(1)
    {
        // lecture portentiomtre
        if (ADCON0bits.GO_nDONE == 0)
        {
            Temp.y[0] =ADRESL;
            Temp.y[1] =ADRESH;
            Valeur_ana = Temp.x;
            Duree_potentiometre = (int)(1.567 * (float)Valeur_ana) + 700;
            ADCON0bits.GO_nDONE = 1;
        }
        
        // le Timer0 est utilis comme base de temps pour la LED, ....
        if (INTCONbits.T0IF)
        {
            INTCONbits.T0IF = 0;
            if (Delai_tempo_LED != 0) Delai_tempo_LED-- ;
            if (Delai_tempo_sequence != 0) Delai_tempo_sequence--;
        }
         
        Clignottement_LED();

        switch (Ptr)
        {
            case 0:
                LED_Nb_flashs = 1;
                // A moduler en fonction des paramtres
                Duree_impulsion_sortie = (int)(coef_a * (float)Duree_impulsion_entree + coef_b);        
                if (Bouton_poussoir == 0)
                {
                    Ptr = 1;
                    Delai_tempo_sequence = 15;
                }
                break;
            case 1:
                // attente appui d'une demi seconde (validation demande modif))
                LED_Nb_flashs = 2;
                if (Bouton_poussoir == 0)
                {
                    if (Delai_tempo_sequence == 0)
                    {
                        Delai_tempo_sequence = 5;
                        Ptr = 2;
                    }
                }
                else
                    Ptr = 0;
                break;
            case 2:
                LED_Nb_flashs = 2;
                // attente relachement bouton
                if (Bouton_poussoir) 
                {
                    if (Delai_tempo_sequence == 0) 
                    {
                        Ptr = 3;
                        Delai_tempo_sequence = 5;
                    }
                }
                break;
            case 3:
                LED_Nb_flashs = 2;
                // position mini
                // on rgle la position du manche et le potentiomtre pour 
                // la position mini
                Duree_impulsion_sortie = Duree_potentiometre;
                if (Bouton_poussoir == 0)
                {
                    if (Delai_tempo_sequence == 0) 
                    {
                        // enregistrement
                        // largeur impulsion envoye par metteur
                        Temp.x = Duree_impulsion_entree;
                        eeprom_write(0, Temp.y[0]);
                        eeprom_write(1, Temp.y[1]);
                        // largeur impulsion  envoyer au servo
                        Temp.x = Duree_potentiometre;
                        eeprom_write(4, Temp.y[0]);
                        eeprom_write(5, Temp.y[1]);
                        Delai_tempo_sequence = 5;
                        Ptr = 4;
                    }
                }
                break;
            case 4:
                LED_Nb_flashs = 3;
                // attente relachement bouton
                if (Bouton_poussoir) 
                {
                    if (Delai_tempo_sequence == 0) Ptr = 5;
                }
                break;
            case 5:
                // position maxi
                // on rgle la position du manche et le potentiomtre pour 
                // la position maxi
                LED_Nb_flashs = 3;
                Duree_impulsion_sortie = Duree_potentiometre;
                if (Bouton_poussoir == 0)
                {
                    // enregistrement maxi dans EEPROM
                    // largeur impulsion envoye par metteur
                    Temp.x = Duree_impulsion_entree;
                    eeprom_write(2, Temp.y[0]);
                    eeprom_write(3, Temp.y[1]);
                    // largeur impulsion  envoyer au servo
                    Temp.x = Duree_potentiometre;
                    eeprom_write(6, Temp.y[0]);
                    eeprom_write(7, Temp.y[1]);
                    
                    lecture_EEPROM();
                    
                    Ptr = 6;
                }
                break;
            case 6:
                LED_Nb_flashs = 3;
                // attente relachement bouton
                if (Bouton_poussoir == 1) Ptr = 0;
                break;
            default:
                Ptr = 0;
                break;
        }
    }
}

void lecture_EEPROM()
{
    // lecture des infos dans l'EEPROM
    
    //  largeur impulsion envoye par metteur
    Temp.y[0] = eeprom_read(0);
    Temp.y[1] = eeprom_read(1);
    Duree_mini_impulsion = Temp.x;
    Temp.y[0] = eeprom_read(2);
    Temp.y[1] = eeprom_read(3);
    Duree_maxi_impulsion = Temp.x;
    
    // largeur impulsion  envoyer au servo
    Temp.y[0] = eeprom_read(4);
    Temp.y[1] = eeprom_read(5);
    Duree_mini_servo = Temp.x;
    Temp.y[0] = eeprom_read(6);
    Temp.y[1] = eeprom_read(7);
    Duree_maxi_servo = Temp.x;
    
    if (Duree_maxi_impulsion == Duree_mini_impulsion)
    {
        coef_a = 1;
        coef_b = 0;
    }
    else
    {
        coef_a = ((float)Duree_maxi_servo - (float)Duree_mini_servo) / ((float)Duree_maxi_impulsion - (float)Duree_mini_impulsion);
        coef_b = (float)Duree_mini_servo - coef_a * (float)Duree_mini_impulsion;        
    }
}

void main_init()
{
    /*
    LED_3 PORTCbits.RC3
    Entree_servo PORTAbits.RA2
    Sortie_servo PORTAbits.RA5
    Potentiometre PORTAbits.RA0
    Bouton_poussoir PORTAbits.RA3
    */

    // oscillateur  8MHz
    OSCCONbits.IRCF0 = 1;
    OSCCONbits.IRCF1 = 1;
    OSCCONbits.IRCF2 = 1;
    OSCCONbits.SCS = 1;

    // entre servo qui provoque interruption
    TRISBbits.TRISB6 = 1;       // RB6
    INTCONbits.RABIE = 1;
    IOCBbits.IOCB6 = 1;         // interruption au changement d'tat
    
    // sortie servo
    TRISBbits.TRISB5 = 0;       // RB5-AN1
    ANSELbits.ANS1 = 0;
    
    // LED
    TRISCbits.TRISC2 = 0;       // RC2/ANS6
    ANSELbits.ANS6 = 0;
    
    // RA4 bouton poussoir
    TRISAbits.TRISA4 = 1;       // RA5
    ANSELbits.ANS3 = 1;         // digital I/O
    
    
    
    // TMR0 utilis pour gestion LED - T = 33 ms
    OPTION_REGbits.T0CS = 0;    // oscilateur = Fosc/4
    OPTION_REGbits.PSA = 0;     // Prescaler is assigned to the Timer0 module
    OPTION_REGbits.PS = 0b111;  // prescaler par 256
    
        
    // TMR1 gnre une impusion toutes les 20 ms (impulsion servo))
    T1CONbits.TMR1CS = 0;        // oscillateur interne fosc/4
    T1CONbits.T1OSCEN = 0;
    T1CONbits.T1CKPS = 0b01;     // prescaler par 8
    T1CONbits.TMR1ON = 1;       // enable TMR1
    T1CONbits.nT1SYNC = 1;
    
    // configuration du compare
    CCP1CONbits.CCP1M3 = 1;
    CCP1CONbits.CCP1M2 = 0;
    CCP1CONbits.CCP1M1 = 1;
    CCP1CONbits.CCP1M0 = 0;
      
    // configuration RA0/AN0 comme entre analogique
    TRISAbits.TRISA0 = 1;
    ANSELbits.ANS0 = 1;
    ANSELH = 0;
    ADCON0bits.VCFG = 0;
    ADCON0bits.ADFM = 1;        // left justified (0 = left   1 = right)
    ADCON0bits.CHS0 = 0;        // slection de RA2
    ADCON0bits.CHS1 = 0;
    ADCON0bits.CHS2 = 0;
    ADCON0bits.CHS3 = 0;
    ADCON0bits.ADON = 1;
    ADCON1bits.ADCS0 = 1;       // frquence de conversion = Fosc/16
    ADCON1bits.ADCS1 = 0;
    ADCON1bits.ADCS2 = 1;
            
    PIE1bits.ADIE = 0;          // interruption en fin de conversion
    PIE1bits.TMR1IE = 0;        // interruption si overflow du TMR1
    PIE1bits.CCP1IE = 1;        
    INTCONbits.PEIE = 1;
    INTCONbits.INTE = 1;
    INTCONbits.RABIE = 1;
     
    INTCONbits.GIE = 1;         // on autorise les interruptions aprs l'

}

void Clignottement_LED(void)
{
    // apel toutes les 33 ms
    
    static char _temp = 0;
    if (Delai_tempo_LED == 0)
    {
        Delai_tempo_LED = 3;
        if ((LED_Cptr % 2) == 0)
        {
            LED = 0;
        }
        else
        {        
            if (LED_Cptr < 2*LED_Nb_flashs)
                LED = 1;
            else
                LED = 0;
        }
        if (LED_Cptr++ == 8)LED_Cptr = 0;
    }
}
